<?php
/*
Plugin Name: mLanguage
Plugin URI: http://www.gnomx.at/mlang
Description: Adds Multilanguage Support to WP 
Version: 1.5.4
Author: Sirlon
Author URI: http://www.gnomx.at

*/

/*  
	Copyright
	----------
	
	mLanguage2009 by Gnomx.at.
	
    This file is part of mLanguage.

    mLanguage is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mLanguage is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with mLanguage.  If not, see <http://www.gnu.org/licenses/>.
*/


define( 'WPMLANG_VERSION', '1.5.4' );

if ( ! defined( 'WPMLANG_PLUGIN_NAME' ) )
	define( 'WPMLANG_PLUGIN_NAME', 'mlanguage');

if ( ! defined( 'WPMLANG_PLUGIN_DIR' ) )
	define( 'WPMLANG_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . plugin_basename( dirname( __FILE__ ) ) );

if ( ! defined( 'WPMLANG_PLUGIN_URL' ) )
	define( 'WPMLANG_PLUGIN_URL', WP_PLUGIN_URL . '/' . plugin_basename( dirname( __FILE__ ) ) );


$defLang = array(
		0 => array ( 'lang' => 'en',
				 	 'default' => '1',
				 	 'title' => 'English',
					 'img' => 'en',
					 'feed' => 'true',
					 'feednote' => '1',
					 'showtitle' => '0',
					 'rdir' => 'ltr'),
		1 => array ( 'lang' => 'de',
				 	 'default' => '0',
				 	 'title' => 'Deutsch',
					 'img' => 'de-at',
					 'feed' => 'false',
					 'feednote' => '1',
					 'showtitle' => '0',
					 'rdir' => 'ltr'));



require_once WPMLANG_PLUGIN_DIR . '/options.php';


function mlang_default()
{
	global $defLang;
	$a = get_option("mlang_lang");
	
	if(empty($a))
	{
		add_option("mlang_lang", $defLang);
		$a = $defLang;
	}

	$s = substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2);
	
	if($_COOKIE["WPmlang"]) $s = substr($_COOKIE["WPmlang"], 0, 2);

	$override = 0;

	for ($i=0;$i<count($a);$i++)
	{
		if($s == $a[$i]['lang'] ) $override = 1;
	}
	
	if($override)
	{
		for ($i=0;$i<count($a);$i++)
		{
			if($a[$i]['lang']==$s) 	$a[$i]['default']=1;
		
			else $a[$i]['default']=0;
		}
	}
	
	return $a;
}

function mlang_add_scripts()
{
	wp_enqueue_script('jquery');
	wp_enqueue_script('mlanguage',WPMLANG_PLUGIN_URL.'/mlanguage.js',array('jquery'));
}

			 
function mlang_add_header() {
	
	$lang = mlang_default();
	foreach($lang as $l)
	{
		if($l['feed'])
		echo "\n<link rel=\"alternate\" type=\"application/rss+xml\" title=\"".get_bloginfo('name')." ".$l['title']." RSS Feed\" href=\"feed:".get_bloginfo('url') ."/?feed=". $l['lang']."\" />\n";
	}
	
}

function mlang_curPageURL() {
 $pageURL = 'http';
 if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
 $pageURL .= "://";
 if ($_SERVER["SERVER_PORT"] != "80") {
  $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
 } else {
  $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
 }
 return $pageURL;
}


//_____________________________
// Check Page Content

function get_div($m, $d, $r, $dir)
{
	if($d==1) return "<div class='$r' style='' lang='$r' dir='$dir'>\n".$m."\n</div>";
    else return "<div class='$r' style='display:none;' lang='$r' dir='$dir'>\n".$m."\n</div>";
}


function mlang_content($content)
{
        $languages = mlang_default();
		$al = array();
		
		$feedname = $_REQUEST['feed'];
		if(empty($feedname))
		{ 
			$s = substr(mlang_curPageURL(), -3);
			
			if(substr($s,0,1) == '/')
				$feedname = substr($s,-2);
		} 
		
		$feedexist = 0;
		
		$feednote = 0;
		
	
	foreach($languages as $lang)
	{
		if($lang['lang'] == $feedname && $lang['feed']){ $feednote = $lang['feednote']; $feedexist = 1;}
	}

	foreach ($languages as $lang)
	{
		$replace="%\[".$lang['lang'].".*(?:/([^'/]*)/)?\s*(?:/([^'/]*)/)?\s*\](.*)\[/".$lang['lang']."\]%isU";
		
		
		if(is_feed() && !empty($feedname) && $feedexist == 1)
			{	
			
					if($feedname != $lang['lang'])
					{
						if(substr(phpversion(),0,1) == '5')
						{
							$content = preg_replace($replace, " ", $content, -1, $rcount);
							$al[count($al)] = $lang['title'];
						} 
						else
						{
							$content = preg_replace($replace, " ", $content);
						}
					}
					else
					{	
						$content = preg_replace($replace, get_div('\\3',1, $lang['lang'], $lang['rdir']), $content );
							
						
					}
			
				
			}
			elseif(is_feed() && $lang['default'] != 1)
			{	
				if(substr(phpversion(),0,1) == '5'){
				$content = preg_replace($replace, " ", $content,-1, $rcount);
				$al[count($al)] = $lang['title'];
				} else
				{
				$content = preg_replace($replace, " ", $content);
				}
				
		
			}
  		   else {
			 
				$content = preg_replace($replace, get_div('\\3', $lang['default'], $lang['lang'], $lang['rdir']), $content );
				
				if(!isset($lang['feednote']))
					$feednote = 0;
				else
					$feednote = $lang['feednote'];
			}
	}
	

	if(is_feed() && $rcount > 0 && $feednote == 1){
	$content = $content."<br /><br /><br /><p><small>This Article is also available in <b>".implode(', ',$al)."</b>.</small></p>";
	}

	return $content;
}

function mlang_title($title)
{
	
	$tt = get_option("mlang_titleTag");
	if(isset($tt)) $titleTag = $tt;
	
	$feedname = $_REQUEST['feed'];
		if(empty($feedname))
		{ 
			$s = substr(mlang_curPageURL(), -3);
			if(substr($s,0,1) == '/')
				$feedname = substr($s,-2);
		}
		
		$feedexist = 0;
	
	$id=get_the_ID();
	
	if(is_single() || is_page() || is_home() || is_category() || is_feed())
	{
			
	global $defLang;
	$a = get_option("mlang_lang");
	
	if(!isset($a))
	{
		add_option("mlang_lang", $defLang);
		$a = $defLang;
	}
			
		$default = 0;
	
		$c = substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2);
	
		if($_COOKIE["WPmlang"]) $c = $_COOKIE["WPmlang"];
		
	foreach($a as $lang)
	{
		if($lang['lang'] == $feedname && $lang['feed']) $feedexist = 1;
	}
		
		$l = get_post_custom($id);
		
		foreach ($a as $lang)
		{
			
			
			if(is_feed() && isset($feedname) && $feedexist = 1)
			{
				if($l[$feedname][0])
					return $l[$feedname][0];
				else
					return $title;
			}
			elseif(is_feed() && $lang['default'] == 1)
			{
				if($l[$lang['lang']][0])
					return $l[$lang['lang']][0];
				else
					return $title;
			}
			else
			{	

						
			if($l[$lang['lang']][0])
			{
				$titolo .= '<span class="'.$lang['lang'].'" lang="'.$lang['lang'].'" dir="'.$lang['dir'].'" style="display:';
			
				if($lang['lang']==$c) 
				{
					$titolo.= 'block;">';
					$default = 1;
				}
				else $titolo.= 'none;">';
						
				$titolo.= $l[$lang['lang']][0]."</span>";
			}
		}
		}
		
		if(empty($titolo)) return $title;
		
		foreach ($a as $lang)
		{
			if($lang['default']==1) 
			{
				$titolo .= '<span class="'.$lang['lang'].'" lang="'.$lang['lang'].'" dir="'.$lang['dir'].'" style="display:';
			
				if($lang['lang']==$c || $default==0) $titolo.= 'block;">';
				else $titolo.= 'none;">';
						
				$titolo .= $title."</span>";
			}	
		}
	
		return $titolo;
	}

	else return $title;

}


//_____________________________
// Menu Function

function mlang_menu()
{

		
		
		$home = get_settings('siteurl');

		$languages = mlang_default();
		
	
		foreach ($languages as $l)
		{
			
			echo " <a href=\"javascript:void(null);\" class=\"mlang-menu-link\" onclick=\"";
			
						if(isset($l['img']))
						{ 
							$img = $l['img'];
						}
						else
						{
							$img = $l['lang'];
							$l['img'] = $img;
						}
  							
			foreach ($languages as $u)
  				if($u['lang']!=$l['lang']) echo "mlang('".$u['lang']."',document.getElementById('".$u['lang']."u'),'$home', 1,'".$u['img']."');";
													
  			echo "mlang('".$l['lang']."', this,'$home', 0,'".$l['img']."');\" id=\"".$l['lang']."u\" title=\"".$l['title']."\">";
			echo "<img class=\"mlang-menu-image\" src=\"".WPMLANG_PLUGIN_URL."/img/";
                        if($l['default']!=1)echo"d";
			echo $img.".png\" id='".$l['lang']."i' border='0' alt='".$l['title']."' />";
			if($l['showtitle'] == 1) echo"<span class=\"mlang-menu-title\">".$l['title']."</span>";
			echo "</a>";
  		}  				
}	

//_____________________________
// Widget

class mLang_Widget extends WP_Widget {
	
	function mLang_Widget()
	{
		$widget_ops = array('classname' => 'widget_mlang', 'description' => 'Adds a Language Menu.' );
		parent::WP_Widget(false, $name = 'mLanguage Flag Menu', $widget_ops);
	}
	
	 function widget($args, $instance)
	{
		extract($args, EXTR_SKIP);
		
		$title = $instance['title'];
		echo $before_widget;
		if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
		mlang_menu();
		echo $after_widget; 
	}

	function update($new_instance, $old_instance)
	{
		return $new_instance;
	}
	
	function form($instance) 
	{
		$title = esc_attr($instance['title']);
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
        <?php
	} 
}
function mlang_init_widget()
{
	return register_widget('mLang_Widget');
}

//_____________________________
//Editor Plugin

function mlang_addbutton()
{
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
 
   if ( get_user_option('rich_editing') == 'true') {
    	add_filter("mce_external_plugins", "add_mlang_tinymce_plugin");
     	add_filter("mce_buttons", "register_mlang_button");
   }	
}

function register_mlang_button($buttons) 
{
   array_push($buttons, "separator", "mlang");
   return $buttons;
}

function add_mlang_tinymce_plugin($plugin_array) {
   $plugin_array['mlang'] = WPMLANG_PLUGIN_URL."/editor_plugin.js";
   return $plugin_array;
}

//_____________________________
// Add Feeds

function mlang_create_feed() {
	load_template(ABSPATH."/wp-includes/feed-rss2.php");
}


function mlang_rewrite_rules($wp_rewrite) 
{
	$new_rules = array(
    'feed/(.+)' => 'index.php?feed='.$wp_rewrite->preg_index(1)
  );
  $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
}

function mlang_add_feed()
{
	$languages = mlang_default();
	global $wp_rewrite;
		
	
		foreach ($languages as $l)
		{
			if($l['feed'])
			{
				add_feed($l['lang'], "mlang_create_feed");
			}
		}
  add_action('generate_rewrite_rules', 'mlang_rewrite_rules');
  $wp_rewrite->flush_rules();
}

//____________________________
// Hide non Default languages

function hide_nondef() 
{
	$lang = mlang_default();
	
	
	$eString = "<!-- mLanguage --> \n <script type=\"text/javascript\">jQuery(document).ready(function($){";
	foreach($lang as $l)
	{
			if($l['default'] == 0)
				$eString .= "$(\".". $l['lang']."\").hide();";
	}
	$eString .= "});</script>";
	
	echo $eString;
	
}

//_____________________________
// Register with WP

add_action('init', 'mlang_add_scripts');
add_action('wp_head', 'mlang_add_header');
add_action('widgets_init', 'mlang_init_widget');
add_action('wp_footer', 'hide_nondef');

add_action('init', 'mlang_addbutton');
add_action('init', 'mlang_add_feed');

add_filter('the_content', 'mlang_content', 2);
add_filter('the_title', 'mlang_title');

?>